## mingw-w64-boost-1.85.0-4.src.tar.zst

=== libs/unordered/CMakeLists.txt ===
# Generated by `boostdep --cmake unordered`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_unordered VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_unordered INTERFACE)
add_library(Boost::unordered ALIAS boost_unordered)

target_include_directories(boost_unordered INTERFACE include)

target_link_libraries(boost_unordered
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container_hash
    Boost::core
    Boost::mp11
    Boost::predef
    Boost::throw_exception
)

target_compile_features(boost_unordered INTERFACE cxx_std_11)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/nowide/test/CMakeLists.txt ===
# Copyright 2019 - 2021 Alexander Grund
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wsuggest-override _BOOST_NOWIDE_SUGGEST_OVERRIDE_SUPPORTED)

add_library(boost_nowide_file_test_helpers STATIC file_test_helpers.cpp)
target_link_libraries(boost_nowide_file_test_helpers PRIVATE Boost::nowide)
target_compile_definitions(boost_nowide_file_test_helpers PRIVATE BOOST_ALL_NO_LIB)

if(NOT TARGET tests)
  add_custom_target(tests)
endif()
  
if(NOT BOOST_SUPERPROJECT_SOURCE_DIR)
  find_package(Boost 1.56 REQUIRED COMPONENTS filesystem system)
endif()

# In some environments this test (part) may fail, so allow to disable it
option(BOOST_NOWIDE_DISABLE_CIN_TEST "Disable integration test using console input" OFF)

function(boost_nowide_add_test name)
  cmake_parse_arguments(PARSE_ARGV 1 ARG "COMPILE_ONLY" "SRC" "LIBRARIES;DEFINITIONS;ARGS")
  if(NOT ARG_SRC)
    set(ARG_SRC ${name}.cpp)
  endif()
  set(name ${PROJECT_NAME}-${name})
  
  add_executable(${name} ${ARG_SRC})
  add_dependencies(tests ${name})
  target_link_libraries(${name} PRIVATE Boost::nowide ${ARG_LIBRARIES})
  boost_add_warnings(${name} pedantic ${Boost_NOWIDE_WERROR})
  if(_BOOST_NOWIDE_SUGGEST_OVERRIDE_SUPPORTED)
    target_compile_options(${name} PRIVATE -Wsuggest-override -Wno-error=suggest-override)
  endif()
  target_compile_definitions(${name} PRIVATE BOOST_ALL_NO_LIB ${ARG_DEFINITIONS})
  if(NOT ARG_COMPILE_ONLY)
    add_test(NAME ${name} COMMAND ${name} ${ARG_ARGS})
  endif()
endfunction()

boost_nowide_add_test(test_codecvt)
boost_nowide_add_test(test_convert)
boost_nowide_add_test(test_env)
boost_nowide_add_test(test_env_win SRC test_env.cpp DEFINITIONS BOOST_NOWIDE_TEST_INCLUDE_WINDOWS)
boost_nowide_add_test(test_fs LIBRARIES Boost::filesystem)
boost_nowide_add_test(test_filebuf LIBRARIES boost_nowide_file_test_helpers)
boost_nowide_add_test(test_ifstream LIBRARIES boost_nowide_file_test_helpers)
boost_nowide_add_test(test_ofstream LIBRARIES boost_nowide_file_test_helpers)
boost_nowide_add_test(test_fstream LIBRARIES boost_nowide_file_test_helpers)
boost_nowide_add_test(test_fstream_special LIBRARIES boost_nowide_file_test_helpers)
boost_nowide_add_test(test_iostream LIBRARIES boost_nowide_file_test_helpers)
if(BOOST_NOWIDE_DISABLE_CIN_TEST)
    target_compile_definitions(${PROJECT_NAME}-test_iostream PRIVATE BOOST_NOWIDE_DISABLE_CIN_TEST)
endif()
boost_nowide_add_test(test_iostream_interactive COMPILE_ONLY SRC test_iostream.cpp DEFINITIONS BOOST_NOWIDE_TEST_INTERACTIVE LIBRARIES boost_nowide_file_test_helpers)
boost_nowide_add_test(test_stackstring)
boost_nowide_add_test(test_stat)
boost_nowide_add_test(test_stdio)
boost_nowide_add_test(test_system_n SRC test_system.cpp DEFINITIONS BOOST_NOWIDE_TEST_USE_NARROW=1)
if(WIN32)
  boost_nowide_add_test(test_system_w SRC test_system.cpp DEFINITIONS BOOST_NOWIDE_TEST_USE_NARROW=0)
  boost_nowide_add_test(test_system_use_windows_h SRC test_system.cpp DEFINITIONS BOOST_NOWIDE_TEST_USE_NARROW=0 BOOST_USE_WINDOWS_H)
  boost_nowide_add_test(test_system_use_windows_h_lean SRC test_system.cpp DEFINITIONS BOOST_NOWIDE_TEST_USE_NARROW=0 BOOST_USE_WINDOWS_H WIN32_LEAN_AND_MEAN)
else()
  foreach(test test_filebuf test_ifstream test_ofstream test_fstream test_fstream_special)
    boost_nowide_add_test(${test}_internal SRC ${test}.cpp DEFINITIONS BOOST_NOWIDE_USE_FILEBUF_REPLACEMENT=1 LIBRARIES boost_nowide_file_test_helpers)
  endforeach()
endif()
boost_nowide_add_test(test_traits DEFINITIONS BOOST_NOWIDE_TEST_BFS_PATH LIBRARIES Boost::filesystem)

# Test that passthrough writes everything from stdin to stdout
# Needs to be done with CMake as the test driver to write any input to stdin and check output
add_test(
  NAME ${PROJECT_NAME}-test_iostream_passthrough
  COMMAND ${CMAKE_COMMAND}
    -D TEST_BINARY=$<TARGET_FILE:${PROJECT_NAME}-test_iostream>
    -P ${CMAKE_CURRENT_SOURCE_DIR}/test_iostream_passthrough.cmake
)

boost_nowide_add_test(benchmark_fstream COMPILE_ONLY DEFINITIONS BOOST_NOWIDE_USE_FILEBUF_REPLACEMENT=1)

=== libs/tuple/test/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

include(BoostTestJamfile OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

if(HAVE_BOOST_TEST)

boost_test_jamfile(FILE Jamfile LINK_LIBRARIES Boost::tuple Boost::core)

endif()

=== libs/unordered/test/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

include(BoostTestJamfile OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

if(HAVE_BOOST_TEST)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

set(BOOST_TEST_LINK_LIBRARIES Boost::unordered Boost::core Boost::concept_check Boost::tuple)

function(fca_tests)
  boost_test(PREFIX boost_unordered ${ARGN})
endfunction()

function(foa_tests)
  boost_test(PREFIX boost_unordered_foa COMPILE_DEFINITIONS BOOST_UNORDERED_FOA_TESTS ${ARGN})
endfunction()

function(cfoa_tests)
  boost_test(PREFIX boost_unordered_cfoa LINK_LIBRARIES Boost::compat Boost::iterator Threads::Threads ${ARGN})
endfunction()

# FCA tests

fca_tests(SOURCES unordered/prime_fmod_tests.cpp)
fca_tests(SOURCES unordered/fwd_set_test.cpp)
fca_tests(SOURCES unordered/fwd_map_test.cpp)
fca_tests(SOURCES unordered/allocator_traits.cpp)
fca_tests(SOURCES unordered/minimal_allocator.cpp)
fca_tests(SOURCES unordered/compile_set.cpp)
fca_tests(SOURCES unordered/compile_map.cpp)
fca_tests(SOURCES unordered/noexcept_tests.cpp)
fca_tests(SOURCES unordered/link_test_1.cpp unordered/link_test_2.cpp)
fca_tests(SOURCES unordered/incomplete_test.cpp)
fca_tests(SOURCES unordered/simple_tests.cpp)
fca_tests(SOURCES unordered/equivalent_keys_tests.cpp)
fca_tests(SOURCES unordered/constructor_tests.cpp)
fca_tests(SOURCES unordered/copy_tests.cpp)
fca_tests(SOURCES unordered/move_tests.cpp)
fca_tests(SOURCES unordered/post_move_tests.cpp)
fca_tests(SOURCES unordered/assign_tests.cpp)
fca_tests(SOURCES unordered/insert_tests.cpp)
fca_tests(SOURCES unordered/insert_stable_tests.cpp)
fca_tests(SOURCES unordered/insert_hint_tests.cpp)
fca_tests(SOURCES unordered/emplace_tests.cpp)
fca_tests(SOURCES unordered/unnecessary_copy_tests.cpp)
fca_tests(SOURCES unordered/erase_tests.cpp COMPILE_DEFINITIONS BOOST_UNORDERED_SUPPRESS_DEPRECATED)
fca_tests(SOURCES unordered/erase_equiv_tests.cpp)
fca_tests(SOURCES unordered/extract_tests.cpp)
fca_tests(SOURCES unordered/node_handle_tests.cpp)
fca_tests(SOURCES unordered/merge_tests.cpp)
fca_tests(SOURCES unordered/find_tests.cpp)
fca_tests(SOURCES unordered/at_tests.cpp)
fca_tests(SOURCES unordered/bucket_tests.cpp)
fca_tests(SOURCES unordered/load_factor_tests.cpp)
fca_tests(SOURCES unordered/rehash_tests.cpp)
fca_tests(SOURCES unordered/equality_tests.cpp)
fca_tests(SOURCES unordered/swap_tests.cpp)
fca_tests(SOURCES unordered/deduction_tests.cpp)
fca_tests(SOURCES unordered/scoped_allocator.cpp)
fca_tests(SOURCES unordered/transparent_tests.cpp)
fca_tests(SOURCES unordered/reserve_tests.cpp)
fca_tests(SOURCES unordered/contains_tests.cpp)
fca_tests(SOURCES unordered/erase_if.cpp)
fca_tests(SOURCES unordered/scary_tests.cpp)
fca_tests(SOURCES exception/constructor_exception_tests.cpp)
fca_tests(SOURCES exception/copy_exception_tests.cpp)
fca_tests(SOURCES exception/assign_exception_tests.cpp)
fca_tests(SOURCES exception/move_assign_exception_tests.cpp)
fca_tests(SOURCES exception/insert_exception_tests.cpp)
fca_tests(SOURCES exception/erase_exception_tests.cpp)
fca_tests(SOURCES exception/rehash_exception_tests.cpp)
fca_tests(SOURCES exception/swap_exception_tests.cpp COMPILE_DEFINITIONS BOOST_UNORDERED_SWAP_METHOD=2)
fca_tests(SOURCES exception/merge_exception_tests.cpp)
fca_tests(SOURCES exception/less_tests.cpp)
fca_tests(SOURCES unordered/narrow_cast_tests.cpp)
fca_tests(SOURCES quick.cpp)

fca_tests(TYPE compile-fail NAME insert_node_type_fail_map COMPILE_DEFINITIONS UNORDERED_TEST_MAP SOURCES unordered/insert_node_type_fail.cpp)
fca_tests(TYPE compile-fail NAME insert_node_type_fail_multimap COMPILE_DEFINITIONS UNORDERED_TEST_MULTIMAP SOURCES unordered/insert_node_type_fail.cpp)
fca_tests(TYPE compile-fail NAME insert_node_type_fail_set COMPILE_DEFINITIONS UNORDERED_TEST_SET SOURCES unordered/insert_node_type_fail.cpp)
fca_tests(TYPE compile-fail NAME insert_node_type_fail_multiset COMPILE_DEFINITIONS UNORDERED_TEST_MULTISET SOURCES unordered/insert_node_type_fail.cpp)

# FOA tests

foa_tests(SOURCES unordered/fwd_set_test.cpp)
foa_tests(SOURCES unordered/fwd_map_test.cpp)
foa_tests(SOURCES unordered/compile_set.cpp)
foa_tests(SOURCES unordered/compile_map.cpp)
foa_tests(SOURCES unordered/noexcept_tests.cpp)
foa_tests(SOURCES unordered/incomplete_test.cpp)
foa_tests(SOURCES unordered/simple_tests.cpp)
foa_tests(SOURCES unordered/equivalent_keys_tests.cpp)
foa_tests(SOURCES unordered/constructor_tests.cpp)
foa_tests(SOURCES unordered/copy_tests.cpp)
foa_tests(SOURCES unordered/move_tests.cpp)
foa_tests(SOURCES unordered/post_move_tests.cpp)
foa_tests(SOURCES unordered/assign_tests.cpp)
foa_tests(SOURCES unordered/insert_tests.cpp)
foa_tests(SOURCES unordered/insert_hint_tests.cpp)
foa_tests(SOURCES unordered/emplace_tests.cpp)
foa_tests(SOURCES unordered/erase_tests.cpp)
foa_tests(SOURCES unordered/merge_tests.cpp)
foa_tests(SOURCES unordered/find_tests.cpp)
foa_tests(SOURCES unordered/at_tests.cpp)
foa_tests(SOURCES unordered/load_factor_tests.cpp)
foa_tests(SOURCES unordered/rehash_tests.cpp)
foa_tests(SOURCES unordered/equality_tests.cpp)
foa_tests(SOURCES unordered/swap_tests.cpp)
foa_tests(SOURCES unordered/transparent_tests.cpp)
foa_tests(SOURCES unordered/reserve_tests.cpp)
foa_tests(SOURCES unordered/contains_tests.cpp)
foa_tests(SOURCES unordered/erase_if.cpp)
foa_tests(SOURCES unordered/scary_tests.cpp)
foa_tests(SOURCES unordered/init_type_insert_tests.cpp)
foa_tests(SOURCES unordered/max_load_tests.cpp)
foa_tests(SOURCES unordered/extract_tests.cpp)
foa_tests(SOURCES unordered/node_handle_tests.cpp)
foa_tests(SOURCES unordered/uses_allocator.cpp)
foa_tests(SOURCES unordered/link_test_1.cpp unordered/link_test_2.cpp )
foa_tests(SOURCES unordered/scoped_allocator.cpp)
foa_tests(SOURCES unordered/hash_is_avalanching_test.cpp)
foa_tests(SOURCES exception/constructor_exception_tests.cpp)
foa_tests(SOURCES exception/copy_exception_tests.cpp)
foa_tests(SOURCES exception/assign_exception_tests.cpp)
foa_tests(SOURCES exception/move_assign_exception_tests.cpp)
foa_tests(SOURCES exception/insert_exception_tests.cpp)
foa_tests(SOURCES exception/erase_exception_tests.cpp)
foa_tests(SOURCES exception/rehash_exception_tests.cpp)
foa_tests(SOURCES exception/swap_exception_tests.cpp)
foa_tests(SOURCES exception/merge_exception_tests.cpp)

# CFOA tests

cfoa_tests(SOURCES cfoa/insert_tests.cpp)
cfoa_tests(SOURCES cfoa/erase_tests.cpp)
cfoa_tests(SOURCES cfoa/try_emplace_tests.cpp)
cfoa_tests(SOURCES cfoa/emplace_tests.cpp)
cfoa_tests(SOURCES cfoa/visit_tests.cpp)
cfoa_tests(SOURCES cfoa/constructor_tests.cpp)
cfoa_tests(SOURCES cfoa/assign_tests.cpp)
cfoa_tests(SOURCES cfoa/clear_tests.cpp)
cfoa_tests(SOURCES cfoa/swap_tests.cpp)
cfoa_tests(SOURCES cfoa/merge_tests.cpp)
cfoa_tests(SOURCES cfoa/rehash_tests.cpp)
cfoa_tests(SOURCES cfoa/equality_tests.cpp)
cfoa_tests(SOURCES cfoa/fwd_tests.cpp)
cfoa_tests(SOURCES cfoa/exception_insert_tests.cpp)
cfoa_tests(SOURCES cfoa/exception_erase_tests.cpp)
cfoa_tests(SOURCES cfoa/exception_constructor_tests.cpp)
cfoa_tests(SOURCES cfoa/exception_assign_tests.cpp)
cfoa_tests(SOURCES cfoa/exception_merge_tests.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test2.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test3.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test4.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test5.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test6.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test7.cpp)
cfoa_tests(SOURCES cfoa/rw_spinlock_test8.cpp)

endif()

=== libs/uuid/test/CMakeLists.txt ===
# Copyright 2024 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

include(BoostTest OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

include(BoostTest OPTIONAL RESULT_VARIABLE HAVE_BOOST_TEST)

if(NOT HAVE_BOOST_TEST)
  return()
endif()

set(BOOST_TEST_LINK_LIBRARIES Boost::uuid Boost::core)

boost_test(TYPE run SOURCES test_uuid.cpp)
boost_test(TYPE run SOURCES test_uuid_no_simd.cpp)

boost_test(TYPE run SOURCES test_io.cpp LINK_LIBRARIES Boost::lexical_cast)

boost_test(TYPE run SOURCES test_nil_generator.cpp)
boost_test(TYPE run SOURCES test_name_generator.cpp)
boost_test(TYPE run SOURCES test_string_generator.cpp)
boost_test(TYPE run SOURCES test_random_generator.cpp)

boost_test(TYPE run SOURCES test_tagging.cpp)

boost_test(TYPE run SOURCES test_uuid_class.cpp)
boost_test(TYPE run SOURCES test_uuid_in_map.cpp)

boost_test(TYPE run SOURCES test_hash.cpp)
boost_test(TYPE run SOURCES test_md5.cpp)
boost_test(TYPE run SOURCES test_sha1.cpp)

boost_test(TYPE run SOURCES test_entropy_error.cpp)

boost_test(TYPE run SOURCES test_detail_random_provider.cpp)

boost_test(TYPE run SOURCES test_serialization.cpp LINK_LIBRARIES Boost::serialization)

=== libs/container_hash/test/cmake_install_test/CMakeLists.txt ===
# Copyright 2018, 2019, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.20)

project(cmake_install_test LANGUAGES CXX)

find_package(boost_container_hash REQUIRED)

add_executable(quick ../quick.cpp)
target_link_libraries(quick Boost::container_hash)

enable_testing()
add_test(quick quick)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

=== libs/geometry/test/algorithms/CMakeLists.txt ===
# Boost.Geometry
# Copyright (c) 2024 Barend Gehrels, Amsterdam, the Netherlands.
# Use, modification and distribution is subject to the Boost Software License,
# Version 1.0. (See accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)

add_subdirectory(area)
add_subdirectory(buffer)
add_subdirectory(convex_hull)
add_subdirectory(detail)
add_subdirectory(envelope_expand)
add_subdirectory(overlay)
add_subdirectory(relate)
add_subdirectory(set_operations)
add_subdirectory(within)

=== libs/lambda2/test/cmake_install_test/CMakeLists.txt ===
# Copyright 2018, 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(cmake_install_test LANGUAGES CXX)

find_package(boost_lambda2 REQUIRED)

add_executable(quick ../quick.cpp)
target_link_libraries(quick Boost::lambda2)

enable_testing()
add_test(quick quick)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

=== libs/url/test/cmake_test/CMakeLists.txt ===
#
# Copyright (c) 2022 alandefreitas (alandefreitas@gmail.com)
#
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt
#

cmake_minimum_required(VERSION 3.5...3.16)

project(cmake_subdir_test LANGUAGES CXX)
set(__ignore__ ${CMAKE_C_COMPILER})
set(__ignore__ ${CMAKE_C_FLAGS})

if(BOOST_CI_INSTALL_TEST)
    # Boost as a package (https://github.com/boostorg/cmake#using-boost-after-building-and-installing-it-with-cmake)
    find_package(Boost CONFIG REQUIRED COMPONENTS url)
elseif(BOOST_CI_INSTALL_MODULE_TEST)
    # Boost.URL as a package
    find_package(boost_url)
elseif(BOOST_CI_BOOST_SUBDIR_TEST)
    # Boost as a subdirectory (https://github.com/boostorg/cmake#using-boost-after-building-and-installing-it-with-cmake)
    if (BUILD_SHARED_LIBS)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
    endif()
    set(BOOST_URL_BUILD_TESTS OFF CACHE BOOL "Build the tests." FORCE)
    set(PREV_BUILD_TESTING ${BUILD_TESTING} OFF CACHE BOOL "Build the tests." FORCE)
    set(BUILD_TESTING OFF CACHE BOOL "Build the tests." FORCE)
    set(BOOST_INCLUDE_LIBRARIES url)
    add_subdirectory(../../../.. boost)
    set(BUILD_TESTING ${PREV_BUILD_TESTING} CACHE BOOL "Build the tests." FORCE)
elseif(BOOST_CI_URL_SUBDIR_TEST)
    # Boost.URL as a subdirectory (https://github.com/boostorg/cmake#using-an-individual-boost-library-with-add_subdirectory)
    if (BUILD_SHARED_LIBS)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
    endif()
    set(BOOST_URL_BUILD_TESTS OFF CACHE BOOL "Build the tests." FORCE)
    set(PREV_BUILD_TESTING ${BUILD_TESTING} OFF CACHE BOOL "Build the tests." FORCE)
    set(BUILD_TESTING OFF CACHE BOOL "Build the tests." FORCE)
    file(GLOB subdirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/../../.. ${CMAKE_CURRENT_SOURCE_DIR}/../../../*)
    foreach(subdir ${subdirs})
        # This is testing the case when the super-project is not available
        # and users want to add libraries as subdirectories.
        # According to the convention above, users should scan all dependencies
        # with boostdep and include each of them with add_subdirectory.
        # For developers, hard-coding all dependencies is impractical
        # and error-prone because the list of transitive dependencies
        # is unstable over time and across Boost versions and branches.
        # For this reason, we list all directories in ../.. and add them
        # as subdirectories. Only directories previously cloned
        # with `depinst.py` in CI will be added. This will unfortunately
        # add test dependencies we don't need.
        if (
            IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../../${subdir} AND
            EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../../${subdir}/CMakeLists.txt
        )
            add_subdirectory(../../../${subdir} boostorg/${subdir})
        endif()
    endforeach()
    if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../../numeric AND IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../../numeric)
        # Iterate potential transitive dependencies in libs/numeric
        file(GLOB subdirs RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/../../../numeric ${CMAKE_CURRENT_SOURCE_DIR}/../../../numeric/*)
        foreach(subdir ${subdirs})
            if (
                IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../../numeric/${subdir} AND
                EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../../../numeric/${subdir}/CMakeLists.txt
            )
                add_subdirectory(../../../numeric/${subdir} boostorg/numeric/${subdir})
            endif()
        endforeach()
    endif()
    set(BUILD_TESTING ${PREV_BUILD_TESTING} CACHE BOOL "Build the tests." FORCE)
endif()

add_executable(main main.cpp)
target_link_libraries(main Boost::url)

if (BUILD_TESTING)
    enable_testing()
    add_test(NAME main COMMAND main)
    add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)
endif()

=== libs/uuid/test/cmake_install_test/CMakeLists.txt ===
# Copyright 2018, 2019, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.20)

project(cmake_install_test LANGUAGES CXX)

find_package(boost_uuid REQUIRED)

add_executable(quick ../quick.cpp)
target_link_libraries(quick Boost::uuid)

enable_testing()
add_test(quick quick)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure -C $<CONFIG>)

=== libs/beast/example/http/client/awaitable-ssl/CMakeLists.txt ===
#
# Copyright (c) 2016-2017 Vinnie Falco (vinnie dot falco at gmail dot com)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Official repository: https://github.com/boostorg/beast
#

GroupSources(include/boost/beast beast)
GroupSources(example/http/client/awaitable "/")

add_executable (http-client-awaitable-ssl
    ${BOOST_BEAST_FILES}
    Jamfile
        http_client_awaitable_ssl.cpp
    )

target_link_libraries(http-client-awaitable-ssl
    OpenSSL::SSL OpenSSL::Crypto
    lib-asio
    lib-asio-ssl
    lib-beast)

set_property(TARGET http-client-awaitable-ssl PROPERTY FOLDER "example-http-client")

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

# mingw logic lives in gcc.jam, so we always need to use the 'gcc' toolset
_toolset=gcc

_realname=boost
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.85.0
_boostver=${pkgver//./_}
pkgrel=4
pkgdesc="Free peer-reviewed portable C++ source libraries (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
url="https://www.boost.org/"
msys2_repository_url="https://github.com/boostorg/boost"
msys2_references=(
  'archlinux: boost'
  "cpe: cpe:/a:boost:boost"
)
license=('spdx:BSL-1.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-bzip2"
         "${MINGW_PACKAGE_PREFIX}-icu"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zstd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${CARCH} == i686 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-python" \
               "${MINGW_PACKAGE_PREFIX}-python-numpy"))
if [[ ${CARCH} != i686 ]]; then
  optdepends=("${MINGW_PACKAGE_PREFIX}-python: For Boost.Python"
              "${MINGW_PACKAGE_PREFIX}-python-numpy: For Boost.Python (NumPy)")
fi
source=(https://boostorg.jfrog.io/artifactory/main/release/${pkgver}/source/boost_${_boostver}.tar.bz2
        boost-1.57.0-build-optflags.patch
        boost-1.57.0-python-abi_letters.patch
        boost-1.57.0-python-libpython_dep.patch
        boost-1.63.0-python-test-PyImport_AppendInittab.patch
        boost-1.68.0-pool-test_linking.patch
        boost-1.70.0-fix-python-install.patch
        using-mingw-w64-python.patch
        msys2-mingw-folders-bootstrap.patch
        boost-1.85.0-container-aliasing.patch
        0010-cmake-prefer-shared-libs-over-static-on-MINGW.patch
        0011-support-numpy-2.patch
        0012-allow-longer-path-on-mingw-w64.patch)
sha256sums=('7009fe1faa1697476bdc7027703a2badb84e849b7b0baad5086b087b971f8617'
            'a23f9afeb620a0e82b6c158d592a555516dd985f82a9e24021f02a29651cb49b'
            'cf46e9b791b45937d5af26b0f35dcdfa416cd9b62ef6c29e3064464835634628'
            '01758929643f92530512230d37df9793e6481cd6ce6310e3a79cee5ba287858c'
            'b22196b6415f5e1c0fe56b49a12ea7c20073b15a5f31907f363c7be38d70d628'
            'c84cbb02321b4df379769f3a3cd03c38c76bdb13abaa3d3f04264ed37c99f2c7'
            '5e5fc9e04482903e1a0e7c6c4e81b57448b8dc86c707d1436d69ddc5010219ff'
            '5c38e08ba63695afa79a29d5d3ea22ef1ecf79f91d48ae922e1a489e83782742'
            '5117629ee577de0da800b6923675683ba69422cdbe958e70c9081fdc6886402e'
            '968844daf8cfb841e12fa24404ae189549ba3bc6e6037651293e4c247b630e90'
            '87e3a33aa402b2f3ea23dc75c6522111ea81b86019aff2ca3779999b82e1acbe'
            '61b1ad6c2ca16e9f99a4705a2526d2e9594f51e6e7df6f11d5f358b70e26dc01'
            'fdc78579f8f057defc59368f22b1304b138b155df13b953b5f10b57c633ed639')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/boost_${_boostver}"

  # https://bugzilla.redhat.com/show_bug.cgi?id=1190039
  apply_patch_with_msg \
    boost-1.57.0-build-optflags.patch

  # https://bugzilla.redhat.com/show_bug.cgi?id=1102667
  apply_patch_with_msg \
    boost-1.57.0-python-libpython_dep.patch \
    boost-1.57.0-python-abi_letters.patch \
    boost-1.63.0-python-test-PyImport_AppendInittab.patch

  # https://svn.boost.org/trac/boost/ticket/9038
  apply_patch_with_msg \
    boost-1.68.0-pool-test_linking.patch

  # Fix installation of both Python versions
  apply_patch_with_msg \
    boost-1.70.0-fix-python-install.patch

  # Use our own build Python
  apply_patch_with_msg \
    using-mingw-w64-python.patch

  apply_patch_with_msg \
    msys2-mingw-folders-bootstrap.patch

  # https://github.com/boostorg/container/commit/20ad12f20e661978e90dc7f36d8ab8ac05e5a5a9
  # https://github.com/msys2/MINGW-packages/issues/17977
  apply_patch_with_msg \
    boost-1.85.0-container-aliasing.patch

  # https://github.com/msys2/MINGW-packages/pull/14790#issuecomment-1519141235
  apply_patch_with_msg \
    0010-cmake-prefer-shared-libs-over-static-on-MINGW.patch

  # https://github.com/boostorg/python/commit/0474de0f6cc9
  apply_patch_with_msg \
    0011-support-numpy-2.patch

  # Building boost 1.83.0 fails because It uses response file to build url library
  # That response file uses backslashes for shared and import library which makes
  # the compilers both GCC and Clang to consider them as escape characters
  # boost/b2 default to use response file when the command line exceeds a certain limit
  # This patch increase that limit to 32000 (Cygwin `getconf ARG_MAX`)
  apply_patch_with_msg \
    0012-allow-longer-path-on-mingw-w64.patch
}

setb2args() {
    case ${CARCH} in
    i686|armv7)
      local _model=32
      ;;
    x86_64|aarch64)
      local _model=64
      ;;
    esac

    if check_option "debug" "y"; then
        local variant=debug
    else
        local variant=release
    fi

    # Extract names of ICU libraries from the pkg-config configuration file.
    # Note that the acual order of the libraries in the array is irrelevant.
    # They are all linked in the same way.
    local -a icu_i18n_libs
    local -a icu_uc_libs
    IFS=" " read -r -a icu_i18n_libs <<< "$(pkgconf --libs-only-l icu-i18n)"
    IFS=" " read -r -a icu_uc_libs <<< "$(pkgconf --libs-only-l icu-uc)"
    local -a icu_libs
    icu_libs=("${icu_i18n_libs[@]}" "${icu_uc_libs[@]}")
    local -a icu_libs_unique
    while IFS= read -r -d '' x
    do
        icu_libs_unique+=("$x")
    done < <(printf "%s\0" "${icu_libs[@]}" | sort -uz)
    # Remove -l prefix.
    icu_libs=("${icu_libs_unique[@]/#-l/}")

    b2args="address-model=${_model} \
    link=shared,static \
    pch=off \
    runtime-link=shared \
    threading=multi \
    threadapi=win32 \
    toolset=$_toolset \
    variant=${variant} \
    --prefix=${pkgdir}${MINGW_PREFIX} \
    --layout=tagged-1.66 \
    -sHAVE_ICU=1 \
    -sICU_PATH=${MINGW_PREFIX} \
    -sICU_ICUDT_NAME=${icu_libs[0]} \
    -sICU_ICUIN_NAME=${icu_libs[1]} \
    -sICU_ICUUC_NAME=${icu_libs[2]} \
    -sICONV_PATH=${MINGW_PREFIX} \
    -sICONV_LINK=\"-L${MINGW_PREFIX}/lib -liconv\" \
    -sNO_BZIP2 \
    -sBZIP2_BINARY=bz2 \
    -sBZIP2_INCLUDE=${MINGW_PREFIX}/include \
    -sBZIP2_LIBPATH=${MINGW_PREFIX}/lib \
    -sNO_ZLIB \
    -sZLIB_BINARY=z \
    -sZLIB_INCLUDE=${MINGW_PREFIX}/include \
    -sZLIB_LIBPATH=${MINGW_PREFIX}/lib \
    -q"
    if [[ "${CARCH}" == "aarch64" ]]; then
      # boost context does not yet have an implementation for Windows ARM64
      # coroutine and fiber depend on context
      b2args+=" --without-context --without-coroutine --without-fiber"
    fi
    if [[ ${CARCH} == i686 ]]; then
      b2args+=" --without-python --without-charconv"
    else
      b2args+=" python=${_pyver}"
    fi
}

build() {
  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})

  [[ -d ${srcdir}/build-${MSYSTEM} ]] && rm -rf ${srcdir}/build-${MSYSTEM}
  cp -rf "${srcdir}/boost_${_boostver}" "${srcdir}/build-${MSYSTEM}"
  cd "${srcdir}/build-${MSYSTEM}"

  if [[ ${CARCH} != i686 ]]; then
    local _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")

    echo "using python : ${_pyver} : ${PREFIX_DEPS}/bin/python.exe : ${PREFIX_DEPS}/include/python${_pyver} : ${PREFIX_DEPS}/lib/python${_pyver}/config-${_pyver} ;" >> ./tools/build/src/user-config.jam
  fi
  # configure b2 to use c++ rather than g++, as the latter no longer exists in
  # clang prefixes
  echo "using gcc : : ${PREFIX_DEPS}/bin/c++.exe ;" >> ./tools/build/src/user-config.jam

  ./tools/build/src/engine/build.sh --cxx="${CXX}" gcc
  cp ./tools/build/src/engine/b2 .

  local -a _bootstrap_args
  if [[ ${CARCH} == i686 ]]; then
    _bootstrap_args+=("--without-libraries=python")
  else
    _bootstrap_args+=("--with-python=${MINGW_PREFIX}")
  fi

  ./bootstrap.sh "${_bootstrap_args[@]}" --with-icu=${MINGW_PREFIX} --with-toolset=$_toolset --with-bjam="$(pwd)/b2"

  setb2args
  ./b2 $b2args -d1 -j$(nproc) \
    cflags="$CFLAGS" \
    cxxflags="$CXXFLAGS -Wno-deprecated-declarations -Wno-ignored-attributes -Wno-unused-command-line-argument" \
    linkflags="$LDFLAGS"
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  local _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")

  setb2args
  ./b2 $b2args -d0 install

  mkdir -p ${pkgdir}${MINGW_PREFIX}/bin
  mv ${pkgdir}${MINGW_PREFIX}/lib/*.dll ${pkgdir}${MINGW_PREFIX}/bin

  # install b2 and bjam
  install -Dm755 b2.exe "${pkgdir}${MINGW_PREFIX}"/bin/b2.exe
  cp -rf "${pkgdir}${MINGW_PREFIX}"/bin/b2.exe "${pkgdir}${MINGW_PREFIX}"/bin/bjam.exe
}
